package org.sonatype.sisu.velocity;

import java.util.List;

import org.apache.velocity.app.VelocityEngine;
import org.apache.velocity.runtime.log.LogChute;
import org.sonatype.sisu.velocity.internal.VelocityConfigurator;

public interface Velocity
{
    /**
     * Key used to bind the "instance id" in VelocityEngine's ApplicationAttributes.
     */
    String INSTANCE_ID = "instanceId";
    
    /**
     * Returns the configured, ready to use, shared (singleton) instance of VelocityEngine.
     * 
     * @return
     */
    VelocityEngine getEngine();

    /**
     * Creates a new engine.
     * 
     * @param id
     * @param logChute
     * @param configurators
     * @return
     */
    VelocityEngine createEngine( final String id, final LogChute logChute,
                                 final List<VelocityConfigurator> configurators );
}
